#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Magenta
#property indicator_color2 Aqua
#property indicator_color3 Red
#property indicator_color4 Aqua
//---- input parameters
extern bool ParabolicFilter = true;
//#############
// Trend Signal
int RISK      = 3;
int CountBars = 3000;
int Alert_Delay_In_Seconds=300;
//#############
// PSar Setting
double Step = 0.02;
double Maximum = 0.1;

double mfi_period = 10;
//---- buffers
double val1[];
double val2[];
double iSar[];
double PrevAlertTime;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(4);
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,234);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,233);
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexArrow(3,159);
   SetIndexBuffer(0,val1);
   SetIndexBuffer(1,val2);
   SetIndexBuffer(3,iSar);
   return(0);
}
//+------------------------------------------------------------------+
//| ASCTrend1sig                                                     |
//+------------------------------------------------------------------+
int start()
{
   SetDefaultSetting();
   if (CountBars>=3000) CountBars=2800;
   SetIndexDrawBegin(0,Bars-CountBars+11+1);
   SetIndexDrawBegin(1,Bars-CountBars+11+1);
   int i,shift,counted_bars=IndicatorCounted();
   int Counter,i1,value10,value11;
   double value1,x1,x2;
   double value2,value3;
   double TrueCount,Range,AvgRange,MRO1,MRO2;
   double Table_value2[3000];
   bool showing = false;   
   value10=3+RISK*2;
   x1=67+RISK;
   x2=33-RISK;
   value11=value10;
//------
// Time
   double j;
   int m,s,k;
   m=Time[0]+Period()*60-CurTime();
   j=m/60.0;
   s=m%60;
   m=(m-m%60)/60;
   ObjectDelete("time");
   if(ObjectFind("time") != 0)
   {
   ObjectCreate("time", OBJ_TEXT, 0, Time[0], Close[0]+ 0.0005);
   ObjectSetText("time", "                  <"+m+":"+s, 12, "Arial", Silver);
   }
   else
   {
   ObjectMove("time", 0, Time[0], Close[0]+0.0005);
   }
//----
   if(Bars<=11+1) return(0);
//---- initial zero
   if(counted_bars<11+1)
   {
      for(i=1;i<=0;i++) val1[CountBars-i]=0.0;
      for(i=1;i<=0;i++) val2[CountBars-i]=0.0;
   }
   int limit=Bars-counted_bars;
   for(i=0; i<limit; i++)
   {
      iSar[i] = iSAR(NULL, 0, Step, Maximum, i);
   }
   shift=CountBars-11-1;
   while(shift>=0)
   {
      Counter=shift;
	   Range=0.0;
	   AvgRange=0.0;
	   for (Counter=shift; Counter<=shift+9; Counter++) AvgRange=AvgRange+MathAbs(High[Counter]-Low[Counter]);
	   Range=AvgRange/10;
	   Counter=shift;
	   TrueCount=0;
      showing=false;         
	   while (Counter<shift+9 && TrueCount<1)
	   {
	     if (MathAbs(Open[Counter]-Close[Counter+1])>=Range*2.0) TrueCount=TrueCount+1;
	 	  Counter=Counter+1;
	   }
	   if (TrueCount>=1) {MRO1=Counter;} else {MRO1=-1;}
	   Counter=shift;
	   TrueCount=0;
      while (Counter<shift+6 && TrueCount<1)
      {
	     if (MathAbs(Close[Counter+3]-Close[Counter])>=Range*4.6) TrueCount=TrueCount+1;
	     Counter=Counter+1;
      }
	   if (TrueCount>=1) {MRO2=Counter;} else {MRO2=-1;}
	   if (MRO1>-1) {value11=3;} else {value11=value10;}
	   if (MRO2>-1) {value11=4;} else {value11=value10;}
	   value2=100-MathAbs(iWPR(NULL,0,value11,shift)); // PercentR(value11=9)
	   Table_value2[shift]=value2;
	   val1[shift]=0;
	   val2[shift]=0;
	   value3=0;
      if (value2<x2)
	   {
	     i1=1;
		  while (Table_value2[shift+i1]>=x2 && Table_value2[shift+i1]<=x1){i1++;}
         if (Table_value2[shift+i1]>x1) 
		   {
			   value3=High[shift]+Range*0.5;
			   if(ParabolicFilter && (iSar[shift] > High[shift] || iSar[shift-1] > High[shift-1]))
			      showing = true;
			   else if (ParabolicFilter == false)
			      showing = true;
			   if (showing) val1[shift]=value3;
		      if (showing && shift==0 && (CurTime() - PrevAlertTime > Period()*Alert_Delay_In_Seconds)) 
            {
               Alert("TrendSignal ",Period()," ",Symbol()," SELL");
               PrevAlertTime = CurTime();
            }
			} 
      }
	   if (value2>x1)
      {
         i1=1;
         while (Table_value2[shift+i1]>=x2 && Table_value2[shift+i1]<=x1){i1++;}
         if (Table_value2[shift+i1]<x2) 
         {
            value3=Low[shift]-Range*0.5;
            if(ParabolicFilter && ((iSar[shift] < Low[shift] || iSar[shift-1] < Low[shift-1])))
               showing = true;
            else if (ParabolicFilter == false)
               showing = true;
            if(showing) val2[shift]=value3;
			   if (showing && shift==0 && (CurTime() - PrevAlertTime > Period()*Alert_Delay_In_Seconds)) 
            {
               Alert("TrendSignal ",Period()," ",Symbol()," BUY");
               PrevAlertTime = CurTime();
            }
			}
		}
      shift--;
   }//end of while
   return(0);
}
//+------------------------------------------------------------------+
void SetDefaultSetting()
{
   string arz = Symbol();
   if (arz == "EURJPY")
   {
      //############
      //1TrendSignal
      RISK             = 8;
      //#############
      //PSar
      Step=0.01;
      Maximum=0.2;
   }else if (arz == "GBPUSD"){
      //############
      //1TrendSignal
      RISK             = 8;
      //#############
      //PSar
      Step=0.01;
      Maximum=0.2;
   }else if (arz == "EURUSD"){
      //############
      //1TrendSignal
      RISK             = 8;
      //#############
      //PSar
      Step=0.01;
      Maximum=0.2;
   }else if (arz == "USDCAD"){
      //############
      //1TrendSignal
      RISK             = 8;
      //#############
      //PSar
      Step=0.01;
      Maximum=0.2;
   }else if (arz == "USDCHF"){
      //############
      //1TrendSignal
      RISK             = 8;
      //#############
      //PSar
      Step=0.01;
      Maximum=0.2;
   }else if (arz == "USDJPY"){
      //############
      //1TrendSignal
      RISK             = 8;
      //#############
      //PSar
      Step=0.02;
      Maximum=0.2;
    }else if (arz == "GOLD"){
      //############
      //1TrendSignal
      RISK             =6;
      //#############
      //PSar
      Step=0.01;
      Maximum=0.2;
   }
}